#include "main.h"
//------------------------------------------------
unsigned int per1;
//------------------------------------------------
void interrupt isr(void)
{
  if(TMR1IE && TMR1IF)
  {
    RA3=1;
    TMR1=0x0000;
    TMR1IF=0;
  }
  if(CCP1IF)
  {
    RA1=1;
    CCP1IF=0;
  }
  if(CCP2IF)
  {
    RA2=1;
    per1+=20;
    CCPR2 = per1;
    CCPR1 = per1>>1; //Use the bit shift to divide by 2 to speed up the operation
    if(per1>=2000) per1=80;
    CCP2IF=0;
  }
}
//------------------------------------------------
void main()
{
  TRISA=0X00;
  PORTA=0X00;
  TRISC2=1;
  CCP1IE=1;
  CCP2IE=1;
  CCP1CON=0X0A; //compare mode CCP
  CCP2CON=0X0B; //compare mode CCP with trigger special event
  per1 = 100;
  CCPR1 = 50;
  CCPR2 = per1;
  CCP1IF=0;
  CCP2IF=0;
  T1CKPS0=1; //Prescaler 8 (1000000/65536/8 ? 1,9 Hz)
  T1CKPS1=1;
  TMR1CS=0;
  TMR1=0x0000;
  TMR1IE=1;
  GIE=0X1;
  PEIE=0X1;
  TMR1ON=1;
  while(1)
  {
  }
}
//------------------------------------------------
